#!/usr/bin/perl

###############################################################################
# admin.cgi                                                                   #
###############################################################################
#
# ImageFolio v 2.1 by BizDesign, Inc.
# written by Greg Raaum, webmaster@imageFolio.com
# Available from http://www.ImageFolio.com
# ---------------------------------------------------------------------------
# PROGRAM NAME : ImageFolio 2.1
# VERSION : 2.1
# LAST MODIFIED : 04/17/2000
# ===========================================================================
# COPYRIGHT NOTICE :
#
# Copyright (c) 1999-2000 BizDesign, Inc. All Rights Reserved.
# Selling the code for this program without prior written consent is
# expressly forbidden.
#
# Obtain written permission before redistributing this software over the 
# Internet or in any other medium.  In all cases copyright and header must
# remain intact.
#
# Feel free to modify the code of this program to suit your likings. 
#
# Although this program has been thoroughly tested on BizDesign's servers, we
# do not warrant that it works on all servers and will not be held liable
# for anything, including but not limited to, misusage, error, or loss of data.
#
# Use at your own risk!
###############################################################################

eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows

    require "../config.pl";               # Change this to full path to config.pl if you have problems.
    require "admin_config.pl";            # Change this to full path to admin_config.pl if you have problems.
    &top;
};

if ($@) { print "Content-type: text/plain\n\nError including configuration file: $@\n"; }
exit;

###############################################################################
# TOP
# Determines what to do
###############################################################################
sub top {
   $|++;   # flush output
   $incoming = $ENV{'QUERY_STRING'};
   @pairs = split(/&/, $incoming);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $FORM{$name} = $value;
   }

   &parse_form;
   &load_values;

   if ($FORM{'login'}) {
      &check_password;
   }
   elsif ($FORM{'logout'}) {
     &logout;
     &login;
   }
   else {
      &get_session;
      &check_file;
      &main;
   }
}

###############################################################################
# CHECK PASSWORD
# Opens the user database to match the username and password
# if it exists we move on, if not we stop.
###############################################################################
sub check_password {

open (USERDB, "$userdb");
   while (<USERDB>) {
      chomp;
      $row=$_;
      @user = split(/\|/,$row);

      if (lc($FORM{'user'}) eq lc($user[0])) {      # username from login form
      $password = crypt($FORM{'password'}, "MM");   # password from login form
         if ($password eq $user[1]) {
            $userid     = $user[2];    $email      = $user[3];
            $firstname  = $user[4];    $lastname   = $user[5];
            $desc_per   = $user[6];    $upload_per = $user[7];
            $addcat_per = $user[8];    $rencat_per = $user[9];
            $delcat_per = $user[10];   $build_per  = $user[11];
            $addusr_per = $user[12];   $modusr_per = $user[13];
            $delusr_per = $user[14];   $passwd     = "Y";
            last;
         }
      }
   }
   close (USERDB);
   if ($passwd eq "Y") {
      &generate_session_id; # Generate a session id
      &create_session;      # See if we have a session already, if not, make one
      &delete_sessions;     # delete inactive files
      &main;
   }
   else {
      if(!$FORM{'user'})        { print &Error('You must enter a username.'); }
      elsif(!$FORM{'password'}) { print &Error('You must enter a password.'); }
      else                      { print &Error('The username and password you entered are incorrect.'); }
      exit;
   }
}

###############################################################################
# MAIN
# Determines what to do
###############################################################################
sub main {
   if ($cgi eq "keywords.pl")        { require "keywords.pl";
      if    ($kwstep eq "2")         { &keywords_step_2; }
      elsif ($kwstep eq "3")         { &keywords_step_3; }
      elsif ($kwstep eq "final")     { &keywords_final;  }
      else  { &keywords_step_1; }
   }
   elsif ($cgi eq "categories.pl")   { require "categories.pl";
      if    ($cataction eq "add")    { &add_category;    }
      elsif ($cataction eq "rename") { &rename_category; }
      elsif ($cataction eq "delete") { &delete_category; }
   }
   elsif ($cgi eq "images.pl")       { require "images.pl";
      if    ($imgaction eq "upload") { &upload_image;    }
      elsif ($imgaction eq "rename") { &rename_image;    }
      elsif ($imgaction eq "delete") { &delete_image;    }
   }
   elsif ($cgi eq "users.pl")       { require "users.pl";
      if    ($useraction eq "modify") { &modify_user;    }
      elsif ($useraction eq "delete") { &delete_user;    }
   }
   else {
      &get_header;
      &show_instructions;
      &get_footer;
   }
   exit;
}

###############################################################################
# GET SESSION
# Gets the session and session file location
###############################################################################
sub get_session {
   if ($FORM{'uid'}) {
     $unique = "$FORM{'uid'}";                 # first, we get the random id
     $sessionid = "$sessions_dir/$unique.ifs"; # second, we get the location
   }
   else {
     $sessionid = "111aaa.11a.ifs";            # give a bogus name if nonexistent
   }
}

###############################################################################
# CHECK FILE
# checks to see if an id file exists before using it
###############################################################################
sub check_file {
   $exists = '1' if -e $sessionid;
   if ($exists eq '1') { &parse_session; }
   else                { &login;   exit; }
}

###############################################################################
# PARSE SESSION
# Opens and reads a session file's contents
###############################################################################
sub parse_session {
   open (SESSION,"$sessionid") || print &Error('Unable to verify your identity.');
   my(@userdata)=<SESSION>;
   close(SESSION);

   open(SESSION,">$sessionid") || print &Error('Unable to verify your identity.');
   flock(SESSION, 2);
   foreach $userdata (@userdata) {
      ($userid, $firstname, $lastname, $email, $desc_per, $upload_per, $addcat_per, $rencat_per, $delcat_per, $build_per, $addusr_per, $modusr_per, $delusr_per) = split(/\|/, $userdata);
      print SESSION "$userid|$firstname|$lastname|$email|$desc_per|";
      print SESSION "$upload_per|$addcat_per|$rencat_per|$delcat_per|";
      print SESSION "$build_per|$addusr_per|$modusr_per|$delusr_per";
   }
   flock(SESSION, 8);
   close(SESSION);
}

###############################################################################
# GENERATE SESSION ID
# when a user logs into to IF, they are assigned a temporary
# session file that will be created containing directory
# information for that user.  After a period of inactivity
# their user id is disabled and they will have to log in again.
###############################################################################
sub generate_session_id {
   $unique      = rand time;                 # first, we get a random id
   $endnum      = substr($unique, 6, 5);
   $endnum      = reverse $endnum;
   $unique      = substr($unique, 0, 4);
   $ipaddress   = reverse $ENV{'REMOTE_ADDR'};
   $ipaddress   = substr($ipaddress, 0, 6);
   $unique     .= "." . $ipaddress . $endnum;
   $FORM{'uid'} = $unique;
   $sessionid = "$sessions_dir/$unique.ifs";  # second, we give a location
}

###############################################################################
# CREATE SESSION
# Creates a new session if one doesn't already exist
###############################################################################
sub create_session {
   open(SESSION,">$sessionid") || print &Error('Unable to verify session id.');
   flock(SESSION, 2);
   print SESSION "$userid|$firstname|$lastname|$email|$desc_per|";
   print SESSION "$upload_per|$addcat_per|$rencat_per|$delcat_per|";
   print SESSION "$build_per|$addusr_per|$modusr_per|$delusr_per";
   flock(SESSION, 8);
   close(SESSION);
}

###############################################################################
# DELETE SESSIONS
# old session files are deleted when a user logs in
###############################################################################
sub delete_sessions {

   opendir (IDS, "$sessions_dir") || print &Error('Unable to read session directory.');
   @sessions = grep { /\.ifs/ } readdir(IDS);
   closedir (IDS);
   $NUMSESSIONS = @sessions;

   if ($NUMSESSIONS > 1) {
     foreach $session (@sessions) {
        if (-M "$sessions_dir/$session" > $session_expiration) {
           unlink("$sessions_dir/$session");
        }
     }
   }
}

###############################################################################
# LOGOUT
# Deletes the current session file for an effective logout
###############################################################################
sub logout {
   if (-e "$sessions_dir/$FORM{'uid'}.ifs") {
      unlink("$sessions_dir/$FORM{'uid'}.ifs");
   }
}

###############################################################################
# LOGIN
# Our login screen
###############################################################################
sub login {

   print "Content-type: text/html\n\n";

print qq|
<html>
<head>

<title>ImageFolio Administration Login</title>|;

if ($use_cookies) { &print_cookie; }

print qq|
</head>
<body bgcolor="#FFFFFF" onLoad="loadWallet()">

<table border=0 cellspacing=0 cellpadding=0 width="100%" height="100%"><tr>
<td valign=middle align=center>

<table border=0 cellspacing=0 cellpadding=0 width=420 bgcolor="#000000"><tr>
<td align=center valign=middle>

<table border=0 cellspacing=1 cellpadding=10 width=420 bgcolor="#000000"><tr bgcolor="#ffcc00">
<td align=center>

<form method=post action="$ENV{'SCRIPT_NAME'}">
<input type=hidden name=login value=1>

<table border=0 cellspacing=0 cellpadding=0 width="100%" bgcolor="#ffffff"><tr><td align=center>
<table border=0 cellspacing=1 cellpadding=0 width="100%"><tr bgcolor="#000000">
<td>&nbsp;&nbsp;<img src="http://www.imagefolio.com/clients/if_images/logo.gif" border=0 alt="BizDesign ImageFolio Login" width=172 height=54></td>
</tr></table></td></tr></table><br><br>

<table border=0 cellpadding=4 width="100%">
  <tr>
    <td align=right><font face="Arial,Helvetica"><b>Username</b> </font></td>
    <td><input type=text name="user" size=25 value=""></td>
  </tr>
  <tr>
    <td align=right><font face="Arial,Helvetica"><b>Password</b> </font></td>
    <td><input type="password" name="password" value="" size=25></td>
  </tr>
</table>

<br><input type="Submit" name=save ONCLICK="saveWallet()" Value="Login"><br>

</td></tr></table></td></tr></table>

<br><br></font><br><br><hr size=1 noshade width=400>
<$admin_small_font>&copy; Copyright 1999-2000 BizDesign, Inc.<br></font>

</td></tr></table>

</form>
</body>
</html>
|;

}

###############################################################################
# GET CATLIST
# We read in the list of all of the categories from the categories.txt file
# which is built by build.pl and create a selection form
###############################################################################
sub get_catlist {
   open (FILE,"$catfile") or &Error ("Could not open category index, $catfile. Reason: $!");
   my(@LINES)=<FILE>;
   @LINES = sort(@LINES);
   close(FILE);
   chomp @LINES;

$catlist .= qq|<select name="category" size="8">|;

   foreach $LINE (@LINES) {
      $space = "";
      ($category, $imagecount) = split(/\t/, $LINE);
      @categories = split (/\//, $category);
      foreach $cat (@categories) {
         $space .= "......";
      }
      $newcategory = pop @categories;
      $newcategory =~ s/_/ /g;
      $space =~ s/\.\.\.\.\.\.//;
      $catlist .= qq|<option value="$category">$space$newcategory|;
   }

$catlist .= qq|</select>|;
}

###############################################################################
# GET IMAGE INFO
# Get some stats about this image
###############################################################################
sub get_image_info {

   chdir(IMAGEDIR,"$image_directory/$category");

   ($thisimage) = $image =~ m,^(.*)\.\w+$,;
   $thisimage =~ s/$mypattern//g;

   foreach $key (keys %extensions) {
      if ( -e "$image_directory/$category/$thisimage.$key" ) {
         $if_filetype =  $extensions{$key}[0];
         $thisimage   =  $thisimage . ".$key";
         $file_type   =  $if_filetype;
         $extfound    =  1;
         ($filesize, $filedate) = (stat($thisimage))[7,9];   #get size, timestamp
         $filedate = &unix_to_date($filedate);               #convert unix time to a legible day
         last;
      }
   }

   if (!$extfound) {
      ($filesize, $filedate) = (stat($image))[7,9];           #get size, timestamp
      $filedate = &unix_to_date($filedate);                   #convert unix time to a legible day
      $file_type = "Not Found!";
   }

   if ($filesize < 1500) { $filesize = commify($filesize) . " bytes"; }
   else { $filesize = int($filesize/1000) . " Kb"; }
}

###############################################################################
# GET HEADER
# The top part of all pages (contains the nav stuff)
###############################################################################
sub get_header {

print "Content-type: text/html\n\n";

print qq|
<!doctype html public "-//w3c//dtd html 3.2 final//en">
<html>
<head>
<title>$site_title Administration : $pagetitle</title>

<style type="text/css">
<!--
  .roll { font-weight:bold; text-decoration:none; color:#000000; }
  A.roll:hover { font-weight:bold; text-decoration:none; color:#ff0000; }
-->
</style>

</head>

<body bgcolor="#ffffff" marginwidth=0 marginheight=0 topmargin=0 leftmargin=0>

<table border=0 cellspacing=0 cellpadding=0 width="100%">

<tr bgcolor="#ff0000"><td width="172"><img src="$if_images_directory/pixel.gif" height=1 width=172 border=0 alt="."></td>
<td width="100%"><img src="$if_images_directory/pixel.gif" height=1 width=1 border=0 alt="."></td></tr>

<tr bgcolor="#000000"><td align=center><img src="$if_images_directory/logo.gif" border=0 alt="BizDesign ImageFolio" width=172 height=54></td>
<td width="100%" align=right>

<table border=0 cellspacing=0 cellpadding=0><tr>
<td><a href="$adminurl?logout=1&uid=$FORM{'uid'}"><img src="$if_images_directory/admin_logout.gif" border=0 alt="Logout" width=61 height=43></a></td>
<td><a href="$adminurl?uid=$FORM{'uid'}"><img src="$if_images_directory/admin_home.gif" border=0 alt="Home" width=61 height=43></a></td>
<td><a href="$imagefolio_url" target="_blank"><img src="$if_images_directory/admin_gallery.gif" border=0 alt="Gallery" width=61 height=43></a></td>
</tr></table>

</td></tr>

<tr bgcolor="#ff0000"><td colspan=2><img src="$if_images_directory/pixel.gif" height=1 width=1 border=0 alt="."></td></tr>

<tr bgcolor="#000000"><td colspan=2><img src="$if_images_directory/spacer.gif" height=10 width="100%" border=0 alt="."></td></tr>
</table>

<table border=0 cellspacing=0 cellpadding=0 width="100%" height="100%">
<tr><td width=150 valign=top bgcolor="#ffcc00"><table border=0 cellspacing=1 cellpadding=4 width="100%">
<tr><td align=center bgcolor="#000000"><$admin_small_font color="#ffcc00"><b>M E N U&nbsp;&nbsp;
&nbsp;O P T I O N S</a></b></font></td></tr>
|;

if ($desc_per eq "Yes") { print qq|
   <tr><td><$admin_font><b><A HREF="$adminurl?cgi=keywords.pl&uid=$FORM{'uid'}" class="roll">+&nbsp;Add Descriptions</a></b></font></td></tr>
|;}


if ($upload_per eq "Yes") { print qq|
   <tr><td><$admin_font><b><A HREF="$adminurl?cgi=images.pl&imgaction=upload&uid=$FORM{'uid'}" class="roll">+&nbsp;Upload Media</a></b></font></td></tr>
|;}


if ($upload_per eq "Yes" || $desc_per eq "Yes") { print qq|
   <tr><td><img src="$if_images_directory/pixel.gif" height=1 width=150 border=0 alt="."></td></tr>
|;}


if ($addcat_per eq "Yes") { print qq|
   <tr><td><$admin_font><b><A HREF="$adminurl?cgi=categories.pl&cataction=add&uid=$FORM{'uid'}" class="roll">+&nbsp;Add Category</a></b></font></td></tr>
|;}


if ($rencat_per eq "Yes") { print qq|
   <tr><td><$admin_font><b><A HREF="$adminurl?cgi=categories.pl&cataction=rename&uid=$FORM{'uid'}" class="roll">+&nbsp;Rename Category</a></b></font></td></tr>
|;}


if ($delcat_per eq "Yes") { print qq|
   <tr><td><$admin_font><b><A HREF="$adminurl?cgi=categories.pl&cataction=delete&uid=$FORM{'uid'}" class="roll">+&nbsp;Delete Category</a></b></font></td></tr>
|;}


if ($addcat_per eq "Yes" || $rencat_per eq "Yes" || $delcat_per eq "Yes") { print qq|
   <tr><td><img src="$if_images_directory/pixel.gif" height=1 width=150 border=0 alt="."></td></tr>
|;}


if ($build_per eq "Yes") { print qq|
   <tr><td><$admin_font><b><A HREF="$buildurl" class="roll">+&nbsp;Build Index</a></b></font></td></tr>
   <tr><td><img src="$if_images_directory/pixel.gif" height=1 width=150 border=0 alt="."></td></tr>
|;}


if ($allow_multiple_users) {

   if ($addusr_per eq "Yes") { print qq|
      <tr><td><$admin_font><b><A HREF="$setup_url" class="roll">+&nbsp;Add New User</a></b></font></td></tr>
   |;}


   if ($modusr_per eq "Yes") { print qq|
      <tr><td><$admin_font><b><A HREF="$adminurl?cgi=users.pl&useraction=modify&uid=$FORM{'uid'}" class="roll">+&nbsp;Modify User</a></b></font></td></tr>
   |;}


   if ($delusr_per eq "Yes") { print qq|
      <tr><td><$admin_font><b><A HREF="$adminurl?cgi=users.pl&useraction=delete&uid=$FORM{'uid'}" class="roll">+&nbsp;Delete User</a></b></font></td></tr>
   |;}

} # end allow multiple users

print qq|
<tr><td><img src="$if_images_directory/pixel.gif" height=1 width=150 border=0 alt="."></td></tr>
<tr><td><$admin_font><b><A HREF="$adminurl?uid=$FORM{'uid'}" class="roll">+&nbsp;Home</a></b></font></td></tr>

<tr><td><$admin_font><b><A HREF="$adminurl?logout=1&uid=$FORM{'uid'}" class="roll">+&nbsp;Logout</a></b></font></td></tr>

<tr><td><img src="$if_images_directory/pixel.gif" height=1 width=150 border=0 alt="."></td></tr>

<tr><td><$admin_font><b><A HREF="http://www.imagefolio.com/forum" target="_blank" class="roll">+&nbsp;Tech Support</a></b></font></td></tr>

<tr><td><$admin_font><b><A HREF="http://www.bizdesign.com" target="_blank" class="roll">+&nbsp;About BizDesign</a></b></font></td></tr>

<tr><td><img src="$if_images_directory/pixel.gif" height=1 width=150 border=0 alt="."></td></tr>

<tr><td align=center>
<br><a href="http://www.imagefolio.com"><img src="http://www.imagefolio.com/imageFolio_Powered.gif" border=0></a></td></tr>

<tr><td align=center><$admin_small_font>&copy; 2000 BizDesign, Inc.</font></td></tr>

</table><br><br></td>

<td valign=top width="100%"><table border=0 cellspacing=0 cellpadding=10 width="100%"><tr><td valign=top>
|;
}

###############################################################################
# GET HEADER
# Bottom piece of all the pages
###############################################################################
sub get_footer {
print qq|
</td></tr></table>
</td></tr></table>
</body>
</html>
|;
}

###############################################################################
# PRINT COOKIE
# Javascript code for saving the username and password for login purposes
###############################################################################
sub print_cookie {

print qq|<SCRIPT LANGUAGE="JavaScript" SRC="cookie.js"><!--
// -->
</SCRIPT>

<SCRIPT LANGUAGE="JavaScript"><!--
function loadWallet() {

 var cookie=document.cookie
 if(nameDefined(cookie,"IF_User")) { 
IFUsername=getCookieValue(cookie,"IF_User")
IFUsername=decode(IFUsername)
 }else IFUsername=""
 document.forms[0].user.value=IFUsername

 if(nameDefined(cookie,"IF_Password")) { 
IFPass=getCookieValue(cookie,"IF_Password")
IFPass=decode(IFPass)
 }else IFPass=""
 document.forms[0].password.value=IFPass

}

function saveWallet() {
IFUsername=window.document.forms[0].user.value
IFPass=window.document.forms[0].password.value

IFUsername=encode(IFUsername)
IFPass=encode(IFPass)

 var newCookie = "IF_User="+IFUsername+"; expires="
 newCookie += "Tuesday, 09-Nov-10 23:12:40 GMT"
 document.cookie=newCookie
 var newCookie = "IF_Password="+IFPass+"; expires="
 newCookie += "Tuesday, 09-Nov-10 23:12:40 GMT"
 document.cookie=newCookie
}

function encode(s) {
t=""
for(var i=0;i<s.length;++i) {
ch=s.charAt(i)
if(ch=="/") t += "//"
else if(ch==" ") t += "/b"
else if(ch==",") t += "/."
else if(ch==";") t += "/:"
else if(ch=="\\n") t += "/n"
else if(ch=="\\r") t += "/r"
else if(ch=="\\t") t += "/t"
else if(ch=="\\b") t += "/b"
else t += ch
}
return t
}
function decode(s) {
// Decode the encoded cookie value
t=""
if(s==null) return t
for(var i=0;i<s.length;++i) {
var ch=s.charAt(i)
if(ch=="/") {
++i
if(i<s.length){
ch=s.charAt(i)
if(ch=="/") t += ch
else if(ch==".") t += ","
else if(ch==":") t += ";"
else if(ch=="n") t += "\\n"
else if(ch=="r") t += "\\r"
else if(ch=="t") t += "\\t"
else if(ch=="b") t += " "
}
}else t += ch
}
return t
}
// --></SCRIPT>
|;
}

###############################################################################
# UNIX TO DATE
# Takes in a unix time and coverts it to legible form
###############################################################################
sub unix_to_date {
my $time   = shift;
my ($sec, $min, $hour, $day, $mon, $year, $dweek, $dyear, $tz) = localtime $time;
my @months = qw!01 02 03 04 05 06 07 08 09 10 11 12!;
$year += 1900;
return "$months[$mon]/$day/$year";
}

###############################################################################
# COMMIFY
# puts commas in those large numbers
###############################################################################
sub commify {
   my $text = reverse $_[0];
   $text =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
   return scalar reverse $text;
}

###############################################################################
# LOAD VALUES
# here we define some commonly used variables
###############################################################################
sub load_values {
   $kwstep     = $FORM{'kwstep'};
   $catstep    = $FORM{'catstep'};
   $cataction  = $FORM{'cataction'};
   $category   = $FORM{'category'};
   $image      = $FORM{'image'};
   $keywords   = $FORM{'keywords'};
   $icaption   = $FORM{'icaption'};
   $tcaption   = $FORM{'tcaption'};
   $type       = $FORM{'type'};
   $cgi        = $FORM{'cgi'};
   $catname    = $FORM{'catname'};
   $imgaction  = $FORM{'imgaction'};
   $imgstep    = $FORM{'imgstep'};
   $useraction = $FORM{'useraction'};
   $userstep   = $FORM{'userstep'};
   $ifuser     = $FORM{'ifuser'};
}

###############################################################################
# SHOW INSTRUCTIONS
# Instructions are displayed if no data is received
###############################################################################
sub show_instructions {
print qq|
<center>
<table border="0" width="100%" cellspacing=0 cellpadding=0 bgcolor="#000000"><tr><td>
<table border="0" width="100%" cellspacing=1 cellpadding=0>

<tr bgcolor="#ffcc00"><td>

<table border="0" width="100%" cellspacing=0 cellpadding=4>
<tr><td><$admin_big_font><b>ImageFolio Administration</b></font></td>
<td align=right><$admin_big_font><b>Menu</b></font></td></tr></table>

</td></tr><tr bgcolor="#eeeeee"><td valign=top>

<table border=0 cellspacing=0 cellpadding=10 width="100%"><tr><td valign=top>

<font face="Arial,Helvetica">

<font color="red"><b>Please Note:</b><br>
<font size=2>Due to security reasons some of the features will actively function but changes will not be saved.</font></font><br><br>


<b>Add Descriptions</b><br>
<font size=2>This allows you to add searchable keywords, captions, and thumbnail captions to your thumbnail images and
related digital media.</font><br><br>

<b>Upload Media</b><br>
<font size=2>This will allow you to upload and add a thumbnail and corresponding
linked file to the category or subcategory of your choice.  The linked file may be
any file type of your choosing, including images, movies, pdf documents, zipped files, etc.</font><br><br>

<b>Add Category</b><br>
<font size=2>This will create a new directory in your image directory
either as a sub-category or main (parent) category.</font><br><br>

<b>Rename Category</b><br>
<font size=2>This allows you to rename an existing directory (category)
in your image directory.</font><br><br>

<b>Delete Category</b><br>
<font size=2>Warning! This will delete an existing directory (category)
and all associated images, sub-directories, and their associated images.</font><br><br>

<b>Build Index</b><br>
<font size=2>This will rebuild both the category and the image index,
saving existing keywords as it goes.</font><br><br>

<b>Add New User</b><br>
<font size=2>This will allow you to add a new user and selectively set permissions for this user.</font><br><br>
 
<b>Modify User</b><br>
<font size=2>This will allow you to modify the name, username, password, email address, or permissions for any user.</font><br><br>

<b>Delete User</b><br>
<font size=2>This will allow you to remove a user from the user database and effectively prevent them from logging in again.</font><br><br>

<b>Logout</b><br>
<font size=2>This will delete your session file and prevent others from accessing the Administration Area using your current session id.</font><br><br>

<b>Home</b><br>
<font size=2>This is the page you are currently reading.</font><br><br>

<b>Gallery</b><br>
<font size=2>This will open a new browser window containing your active image gallery.</font><br><br>

<b>Tech Support</b><br>
<font size=2>This will take you to the ImageFolio Message Board - useful if you are stuck.</font><br><br>
 
<b>About BizDesign</b><br>
<font size=2>Visit the BizDesign site to read and learn more about the makers of this product.</font><br><br>

<font color="red"><b>Please Note:</b><br>
<font size=2>Your user permissions may prevent you from accessing one or more of the administrative features listed above.</font></font><br><br>


</font></td></tr></table>
</td></tr></table>
</td></tr></table>

<br><$admin_small_font>&copy; Copyright 1999-2000 <a href="http://www.bizdesign.com">BizDesign, Inc.</a></font><br><br>
|;
}

###############################################################################
# Error
# shows error message if form not filled out correctly
###############################################################################
sub Error{
   print "Content-type: text/html\n\n";
   local ($whoops) = @_;

print qq|
<script language="JavaScript">
<!--
function help(){
window.alert("Help\\n\\nThis error message is displayed either because I was not able to understand your input or your input was incorrect.");
}
//-->
</script>

</head>

<body bgcolor="#ffffff" marginwidth=0 marginheight=0 topmargin=0 leftmargin=0>

<form>

<table border=0 cellspacing=0 cellpadding=0 width="100%" height="100%"><tr><td valign=middle align=center>
<table border=2 cellspacing=0 cellpadding=0 width="350" bgcolor="#000000"><tr><td>
<table border=0 cellspacing=0 cellpadding=3 width="350"><tr bgcolor="000000">
<td nowrap><$admin_font color="#ffffff"><strong>Error!</strong></font></td>
<td align=right nowrap><$admin_font><b><INPUT TYPE="button" VALUE=" ? " onClick="help()">&nbsp;<INPUT TYPE="button" VALUE=" X " onClick="history.go(-1)"></b></font></td></tr>

<tr bgcolor="#eeeeee">
<td colspan=2><table border=0 cellspacing=0 cellpadding=5 width="100%"><tr>
<td><$admin_font><b><font color="#ff0000">$whoops</font></b><br><br>If the button below does not take you back, please use your browser's back button to go back and try again.<br><br></font></td>
</tr></table>

<center><$admin_font><INPUT TYPE="button" VALUE="     OK     " onClick="history.go(-1)"></font></center>

</td></tr></table></td></tr></table></td></tr></table>
</form>
|;

exit;
}

###############################################################################
# PARSE THE FORM
# Parses the form input and returns a hash with all the name
# value pairs. 
###############################################################################
sub parse_form {
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      if ($FORM{$name} && ($value)) { $FORM{$name} = "$FORM{$name},$value"; }
      elsif ($value) { $FORM{$name} = $value; }
   }
}
