#!/usr/bin/perl

###############################################################################
# admin_config.pl                                                             #
###############################################################################
#
# ImageFolio v 2.1 by BizDesign, Inc.
# written by Greg Raaum, webmaster@imageFolio.com
# Available from http://www.ImageFolio.com
# ---------------------------------------------------------------------------
# PROGRAM NAME : ImageFolio 2.1
# VERSION : 2.1
# LAST MODIFIED : 04/17/2000
# ===========================================================================
# COPYRIGHT NOTICE :
#
# Copyright (c) 1999-2000 BizDesign, Inc. All Rights Reserved.
# Selling the code for this program without prior written consent is
# expressly forbidden.
#
# Obtain written permission before redistributing this software over the 
# Internet or in any other medium.  In all cases copyright and header must
# remain intact.
#
# Feel free to modify the code of this program to suit your likings. 
#
# Although this program has been thoroughly tested on BizDesign's servers, we
# do not warrant that it works on all servers and will not be held liable
# for anything, including but not limited to, misusage, error, or loss of data.
#
# Use at your own risk!
###############################################################################

# This is the configuration script for ImageFolio Administration.  It should be
# placed in the same directory as admin.cgi.


# (1) #########################################################################
# WHAT IS THE FULL PATH TO YOUR USER DATABASE (admin/user.db)?
# Path to the text file containing usernames and encrypted passwords
# For extra security you should store this outside on your Web server if
# possible and rename the default document from 'user.db' to something else

$userdb = "/home/httpd/html/www.imagefolio.com/clients/cgi-bin/admin/user.db";


# (2) #########################################################################
# WHAT IS THE FULL PATH TO YOUR SESSIONS DIRECTORY (admin/sessions)?
# When users log in, they are assigned a session id which will keep their
# session active without having to provide a username and password on every
# page.  Define the path to the directory where user sessions are stored below.

$sessions_dir = "/home/httpd/html/www.imagefolio.com/clients/cgi-bin/admin/sessions";

# (3) #########################################################################
# WHAT IS THE URL TO SETUP.CGI (admin/setup.cgi)?
# setup.cgi is the script used to set up new users for the ImageFolio
# Administration area.  If you change the location from its default, you'll
# need to put the full path to config.pl and admin_config.pl at the top of
# setup.cgi.  To prevent intrusion, YOU SHOULD ALSO RENAME THIS FILE!

$setup_url = "http://www.imagefolio.com/clients/cgi-bin/admin/setup.cgi";


# (4) #########################################################################
# DO YOU WANT TO USE COOKIES FOR EASIER LOGIN?
# If so, it will store a cookie on the computer of each user who accesses this
# interface so next time they log in they won't have to type in a username or
# a password. 1 - Yes, 0 - No

$use_cookies = 1;


# (5) #########################################################################
# AFTER WHAT PERIOD OF INACTIVITY SHOULD SESSION FILES BE DELETED?
# ImageFolio will delete old session files if they have not been used for a
# specific period of time.  This is good security for those who log in and then
# stop working for a while.  The system will automatically lock them out and
# they will have to log in again to continue working.  What length of time would
# you like this to be? example:  1 = 1 day., .25 = 6 hours,  .015 = 36 minutes

$session_expiration = '.015';


# (6) #########################################################################
# DO YOU WANT TO ALLOW MULTIPLE USERS OF IMAGEFOLIO ADMINISTRATION?
# Each user will have their own unique username and password and you'll be able
# to delete and add users through the Administration interface.
# 1 - yes, 0 - no

$allow_multiple_users = 1;


# (7) #########################################################################
# WHAT TYPE STYLES WOULD YOU LIKE TO USE FOR THE BASIC TEXT ON ADMIN PAGES?

$admin_font = 'font face="Verdana,Arial,Helvetica" size="2"';
$admin_small_font = 'font face="Verdana,Arial,Helvetica" size="1"';
$admin_big_font = 'font face="Arial,Helvetica" color="#000000" size=3';

1;

