###############################################################################
# categories.pl                                                               #
###############################################################################
#
# ImageFolio v 2.1 by BizDesign, Inc.
# written by Greg Raaum, webmaster@imageFolio.com
# Available from http://www.ImageFolio.com
# ---------------------------------------------------------------------------
# PROGRAM NAME : ImageFolio 2.1
# VERSION : 2.1
# LAST MODIFIED : 04/17/2000
# ===========================================================================
# COPYRIGHT NOTICE :
#
# Copyright (c) 1999-2000 BizDesign, Inc. All Rights Reserved.
# Selling the code for this program without prior written consent is
# expressly forbidden.
#
# Obtain written permission before redistributing this software over the 
# Internet or in any other medium.  In all cases copyright and header must
# remain intact.
#
# Feel free to modify the code of this program to suit your likings. 
#
# Although this program has been thoroughly tested on BizDesign's servers, we
# do not warrant that it works on all servers and will not be held liable
# for anything, including but not limited to, misusage, error, or loss of data.
#
# Use at your own risk!
###############################################################################

use File::Path;

###############################################################################
# ADD
# Add a new category
###############################################################################
sub add_category {

if ($catstep eq "final") {

   if (!$catname) { &Error ("You must enter a Category Name."); }
   if (!$type) { &Error ("You must select a Category Type."); }

   $catname =~ s/^\s+//g;              # Trim leading blanks...
   $catname =~ s/\s+$//g;              # Trim trailing blanks...
   $catname =~ s/\s+\s+/ /g;           # Change two spaces to one.
   $catname =~ s/\s+/_/g;              # Change spaces to underscores
   $newcatname = $catname;
   $newcatname =~ s/_/ /g;

   if ($type eq "main") {
      $createcat = "$image_directory/$catname";
      $pagetitle = "New Category Added";
      $comment = qq|<$admin_font><b>The category
      <font color=red>$newcatname</font> has been added.<b></font><br><br>|;
   }
   elsif ($type eq "sub") {
      if (!$category) { &Error ("You must select a Parent Category."); }
      $createcat = "$image_directory/$category/$catname";
      $pagetitle = "New Subcategory Added";
      $comment = qq|<$admin_font><b>The subcategory
      <font color=red>$newcatname</font> has been added in <font color=red>$category</font>.<b></font><br><br>|;
   }
   else { &Error ("Something strange happened here.  Please check your categories.pl or admin.cgi files for errors!"); }

   &check_dir ($catname, $createcat);

   mkdir ("$createcat", "0777") or &Error ("Unable to create category, $createcat.  Reason: $!");
   chmod(0777,"$createcat") or &Error ("Could not set permissions on category, $createcat.  Reason: $!");

   $newcatdirect = $createcat;
   $newcatdirect =~ s/$image_directory\///g;

   open(CATEGORIES,">>$catfile") or &Error ("Could not open index file, $catfile.  Try rebuilding the index.  Reason: $!");
   flock(CATEGORIES, 2);
   print CATEGORIES $newcatdirect . "\t" . "0" . "\n";;
   flock(CATEGORIES, 8);
   close(CATEGORIES);

   &show_new_category;
}
else { $pagetitle = "Add Category"; &show_new_category; }

}

###############################################################################
# SHOW NEW CATEGORY
# Shows the add a new category form
###############################################################################
sub show_new_category {

&get_header;
&get_catlist;

print qq|$comment

<form method=get action="$ENV{'SCRIPT_NAME'}">
<input type=hidden name=uid value="$FORM{'uid'}">
<input type=hidden name=cgi value="categories.pl">
<input type=hidden name=cataction value="add">
<input type=hidden name=catstep value=final>

<center>
<table border="0" width="100%" cellspacing=0 cellpadding=0 bgcolor="#000000"><tr><td>
<table border="0" width="100%" cellspacing=1 cellpadding=0>

<tr bgcolor="#ffcc00"><td colspan=2>
<table border="0" width="100%" cellspacing=0 cellpadding=4>
<tr><td><$admin_big_font><b>Add Category</b></font></td>
<td align=right><$admin_big_font><b>Step 1
of 1</b></font></td> </tr></table></td></tr>

<tr bgcolor="#eeeeee"><td width="50%" valign=top>
<table border=0 cellspacing=0 cellpadding=4 width="100%">

<tr><td nowrap><$admin_small_font><b>C A T E G O R Y&nbsp;
&nbsp;&nbsp;N A M E</b></font></td></tr><tr><td><input type=text name="catname"
size=35></td></tr>

<tr><td nowrap><$admin_small_font><b>C A T E G O R Y&nbsp;
&nbsp;&nbsp;T Y P E</b></font></td></tr><tr><td><input type=radio name="type"
value="main"><$admin_small_font>Main Category</font><br>
<input type=radio name="type" value="sub"><font face="Verdana,Arial,Helvetica"
size=1>Subcategory</font></td></tr>

</table>

</td><td width="50%" valign=top>
<table border=0 cellspacing=0 cellpadding=4 width="100%">
<tr><td nowrap><$admin_small_font><b>P A R E N T&nbsp;
&nbsp;&nbsp;C A T E G O R Y</b>&nbsp;&nbsp;(if Subcategory)</font></td></tr>
<tr><td>$catlist</td></tr></table>

</td></tr></table>

</td></tr></table>
<br><input type=submit value="Add New Category">
</center>
</form>
|;

&get_footer;
}

###############################################################################
# RENAME CATEGORY
# This one is difficult because we have to rename the category in four places:
# the directory itself, the captions file, in the image index, and the category
# index.
###############################################################################
sub rename_category {

if ($catstep eq "final") {

   if (!$catname) { &Error ("You must enter a New Category Name."); }
   if (!$category) { &Error ("You must select a Category to Rename."); }

   $catname =~ s/^\s+//g;              # Trim leading blanks...
   $catname =~ s/\s+$//g;              # Trim trailing blanks...
   $catname =~ s/\s+\s+/ /g;           # Change two spaces to one.
   $catname =~ s/\s+/_/g;              # Change spaces to underscores

   @categories = split (/\//, $category);
   $replacetxt = pop @categories;

   $bounce = $category;
   $bounce =~ s/$replacetxt/$catname/g;

   $renamecat = "$image_directory/$category";
   $newname = "$image_directory/$bounce";

   &check_dir ($catname, $newname);

   $pagetitle = "Category Renamed";
   $oldcatname = $category;
   $oldcatname =~ s/_/ /g;
   $newcatname = $bounce;
   $newcatname =~ s/_/ /g;

   $comment = qq|<$admin_font><b>The category
   <font color=red>$oldcatname</font> has been globally renamed.  The new category name is
   <font color=red>$newcatname</font>.<b></font><br><br>|;


# FIRST WE RENAME THE DIRECTORY
   rename ("$renamecat", "$newname") or &Error ("Could not rename category, $renamecat.  Reason: $!");

# SECOND, WE RENAME ALL INSTANCES OF THE OLD CATEGORY IN THE IMAGE INDEX

open (FILE,"$indexfile") or &Error ("Could not open $indexfile, is it created.  Reason: $!");
my(@LINES)=<FILE>;
close(FILE);
chomp @LINES;
$SIZE=@LINES;

open (INDEX,">$indexfile") or &Error ("Could not open $indexfile, is it created.  Reason: $!");
flock(INDEX, 2);

   for ($i=0;$i<=$SIZE;$i++) {
      $_=$LINES[$i];
      my ($filename, $path, $blah, $blah, $keywords) = split(/\|/, $_);

        /^#/      and next;        # Skip comment Lines.
        /^\s*$/   and next;        # Skip blank lines.

      if ($path =~ /^$category/g) {
         $snicker = $path;
         $snicker =~ s/$category/$bounce/g;
         print INDEX "$filename\|$snicker\|\|\|$keywords\n";
      }
      else {
         print INDEX $_ . "\n";
      }
   }

flock(INDEX, 8);
close(INDEX);
chmod(0666,"$indexfile") or &Error ("Could not set permissions on index, $indexfile.  Reason: $!");


# THIRD, WE RENAME THE CAPTIONS TEXT FILE

   $ncat = $category;
   $ncat =~ s/\//\./g;           # Generate filename for our existing captions file
   $rncat = $bounce;
   $rncat =~ s/\//\./g;          # Generate filename for our new captions file

   if (-e "$data_directory/$ncat.captions.txt") {
      rename ("$data_directory/$ncat.captions.txt", "$data_directory/$rncat.captions.txt") or &Error ("Could not rename category, $renamecat.  Reason: $!");
      chmod(0666,"$data_directory/$rncat.captions.txt") or &Error ("Could not set permissions on captions file, $rncat.captions.txt.  Reason: $!");
   }




# FORTH, AND FINALLY, WE RENAME ALL INSTANCES OF THE OLD CATEGORY IN THE CATEGORY INDEX

open (CATFILE,"$catfile") or &Error ("Could not open $catfile, is it created.  Reason: $!");
my(@CATS)=<CATFILE>;
close(CATFILE);
chomp @CATS;
$SIZE=@CATS;

open (CATINDEX,">$catfile") or &Error ("Could not open $catfile, is it created.  Reason: $!");
flock(CATINDEX, 2);

   for ($i=0;$i<=$SIZE;$i++) {
      $_=$CATS[$i];
      my ($direct, $cnt) = split(/\t/, $_);

        /^#/      and next;        # Skip comment Lines.
        /^\s*$/   and next;        # Skip blank lines.

      if ($direct =~ /^$category/g) {
         $doodle = $direct;
         $doodle =~ s/$category/$bounce/g;
         print CATINDEX $doodle . "\t" . $cnt . "\n";
      }
      else {
         print CATINDEX $_ . "\n";
      }
   }

flock(CATINDEX, 8);
close(CATINDEX);
chmod(0666,"$catfile") or &Error ("Could not set permissions on index file, $catfile.  Reason: $!");

   &show_rename;
}
else { $pagetitle = "Rename Category"; &show_rename; }
}

###############################################################################
# SHOW RENAME
# Prints a form for the renaming of an existing category
###############################################################################
sub show_rename {

&get_header;
&get_catlist;

print qq|$comment
<form method=get action="$ENV{'SCRIPT_NAME'}">
<input type=hidden name=uid value="$FORM{'uid'}">
<input type=hidden name=cgi value="categories.pl">
<input type=hidden name=cataction value="rename">
<input type=hidden name=catstep value=final>

<center>
<table border="0" width="100%" cellspacing=0 cellpadding=0 bgcolor="#000000"><tr><td>
<table border="0" width="100%" cellspacing=1 cellpadding=0>

<tr bgcolor="#ffcc00"><td colspan=2>
<table border="0" width="100%" cellspacing=0 cellpadding=4>
<tr><td><$admin_big_font><b>Rename Category</b></font></td>
<td align=right><$admin_big_font><b>Step 1
of 1</b></font></td> </tr></table></td></tr>

<tr bgcolor="#eeeeee"><td width="50%" valign=top>
<table border=0 cellspacing=0 cellpadding=4 width="100%">

<tr><td nowrap><$admin_small_font><b>N E W&nbsp;&nbsp;
&nbsp;C A T E G O R Y&nbsp;&nbsp;&nbsp;N A M E</b></font></td></tr>
<tr><td><input type=text name="catname" size=35></td></tr>

</table>

</td><td width="50%" valign=top>
<table border=0 cellspacing=0 cellpadding=4 width="100%">
<tr><td nowrap><$admin_small_font><b>C A T E G O R Y&nbsp;
&nbsp;&nbsp;T O&nbsp;&nbsp;&nbsp;R E N A M E</b></font></td></tr>
<tr><td>$catlist</td></tr></table>

</td></tr></table>

</td></tr></table>
<br><input type=submit value="Rename Category">
</center>
</form>
|;

&get_footer;

}

###############################################################################
# DELETE CATEGORY
# Deletes a category an all associated images from the Web server.  Does not
# remove category from the database and user must Build the Image Index for
# this to take place.
###############################################################################
sub delete_category {

if ($catstep eq "final") {

   if (!$category) { &Error ("You must select a category for deletion."); }

   $deletecat = "$image_directory/$category";
   $pagetitle = "Category Deleted";
   $newcatname = $category;
   $newcatname =~ s/_/ /g;
   $comment = qq|<$admin_font><b>The category
   <font color=red>$newcatname</font> has been deleted from your Web space. 
   You will need to re-Build your Image Index before this category can be
   completely deleted from the database.<b></font><br><br>|;
   
   rmtree($deletecat) or &Error ("Could not delete category, $category.  Reason: $!");
   &show_delete;
}


elsif ($catstep eq "2") {

   if (!$category) { &Error ("You must select a category for deletion."); }
   $pagetitle = "Delete Category : Confirmation";
   &get_header;

print qq|
<form method=get action="$ENV{'SCRIPT_NAME'}">
<input type=hidden name=uid value="$FORM{'uid'}">
<input type=hidden name=cgi value="categories.pl">
<input type=hidden name=cataction value="delete">
<input type=hidden name=catstep value=final>
<input type=hidden name=category value="$category">

<table border=0 cellspacing=0 cellpadding=0 width="100%" height="100%"><tr>
<td valign=middle align=center>
<table border=2 cellspacing=0 cellpadding=0 width="350" bgcolor="#000000">
<tr><td><table border=0 cellspacing=0 cellpadding=3 width="350"><tr bgcolor="000000">
<td nowrap><$admin_font color="#ffffff"><strong>Warning!</strong>
</font></td></tr>

<tr bgcolor="#eeeeee">
<td><table border=0 cellspacing=0 cellpadding=5 width="100%"><tr>
<td><$admin_font><b><font color="#ff0000">You
are about to delete the category '$category' and all of its associated
images.  Are you sure you want to do this?</font></b><br><br>If not, please
click the Cancel button below.<br><br></font></td></tr></table>

<center><nobr><$admin_font><INPUT TYPE="submit" VALUE="Yes, Delete It!">
&nbsp;<INPUT TYPE="button" VALUE="Cancel" onClick="history.go(-1)"></font></nobr></center>

</td></tr></table></td></tr></table></td></tr></table></form>
|;
&get_footer;
}
else { $pagetitle = "Delete Category"; &show_delete; }
}

###############################################################################
# SHOW DELETE
# Shows the category form so we can select a category for deletion
###############################################################################
sub show_delete {
&get_header;
&get_catlist;

print qq|$comment
<form method=get action="$ENV{'SCRIPT_NAME'}">
<input type=hidden name=uid value="$FORM{'uid'}">
<input type=hidden name=cgi value="categories.pl">
<input type=hidden name=cataction value="delete">
<input type=hidden name=catstep value=2>

<center>

<table border="0" width="100%" cellspacing=0 cellpadding=0 bgcolor="#000000">

<tr><td>

<table border="0" width="100%" cellspacing=1 cellpadding=0>
<tr bgcolor="#ffcc00"><td>

<table border="0" width="100%" cellspacing=0 cellpadding=4>
<tr><td><$admin_big_font><b>Select A Category to Delete</b></font></td>
<td align=right><$admin_big_font><b>Step 1 of 2</b></font></td>
</tr></table></td></tr>

<tr bgcolor="#eeeeee"><td align=center>$catlist</td></tr></table></td></tr></table>

<br><input type=submit value="Delete This Category">

</center>

</form>
|;
&get_footer;
}

###############################################################################
# CHECK DIR
# Make sure we have valid characters in the directory name before building it
###############################################################################
sub check_dir {

    my ($dirname, $dir) = @_;
    my $chrs = quotemeta ("/_-");
    
    if (-e $dir) {
        &Error ("The category '$dirname' already exists, try using another!");
    }
    if ($dirname !~ m,^[\w\d$chrs]+$,) {
        &Error ("Invalid characters in category name '$dirname.'  Please use only letters, numbers, _, / and -.");
    }       
    return $input;
}

1;