###############################################################################
# config.pl                                                                   #
###############################################################################
#
# ImageFolio v 2.1 by BizDesign, Inc.
# written by Greg Raaum, webmaster@imageFolio.com
# Available from http://www.ImageFolio.com
# ---------------------------------------------------------------------------
# PROGRAM NAME : ImageFolio 2.1
# VERSION : 2.1
# LAST MODIFIED : 04/17/2000
# ===========================================================================
# COPYRIGHT NOTICE :
#
# Copyright (c) 1999-2000 BizDesign, Inc. All Rights Reserved.
# Selling the code for this program without prior written consent is
# expressly forbidden.
#
# Obtain written permission before redistributing this software over the 
# Internet or in any other medium.  In all cases copyright and header must
# remain intact.
#
# Feel free to modify the code of this program to suit your likings. 
#
# Although this program has been thoroughly tested on BizDesign's servers, we
# do not warrant that it works on all servers and will not be held liable
# for anything, including but not limited to, misusage, error, or loss of data.
#
# Use at your own risk!
###############################################################################
#
# Answer the following questions, then upload this configuration file to the
# same directory where imageFolio.cgi is
#
# See the README file for more details
#
###############################################################################
# VARIABLE CONFIGURATION SECTION
###############################################################################


# (1) ###################################################################
# WHAT IS THE TITLE OF YOUR SITE
# This could be a domain or company name

$site_title = 'ImageFolio 2.1';

# (2) ###################################################################
# WHAT IS THE FULL PATH TO THE IMAGE DIRECTORY YOUR CREATED?
# the image directory can be place anywhere in your webspace.  The name
# of this directory is not used in category titles.
# i.e. /home/sites/yourdomain/gallery (no trailing slash)

$image_directory = '/home/httpd/html/www.imagefolio.com/demo_images';

# (3) ###################################################################
# WHAT IS THE URL TO THE IMAGE DIRECTORY YOUR CREATED?
# this is the same location as the above, but a URL not a path.
# i.e. http://www.yourdomain.com/gallery (no trailing slash)

$imageurl = 'http://www.imagefolio.com/demo_images';

# (4) ###################################################################
# WHAT IS THE URL TO YOUR imageFolio.cgi FILE?
# Type the URL (web address) to your imageFolio.cgi file below.

$imagefolio_url = 'http://www.imagefolio.com/clients/cgi-bin/imageFolio.cgi';

# (5) ###################################################################
# WHAT IS THE URL TO YOUR imageSearch.cgi FILE?
# Type the URL (web address) to your imageSearch.cgi file below.

$imagesearch_url = 'http://www.imagefolio.com/clients/cgi-bin/imageSearch.cgi';

# (6) ###################################################################
# WHAT IS THE URL TO YOUR admin DIRECTORY?
# Type the URL (address) to your admin directory file below.
# It should be within the same directory as imageFolio.cgi
# (no trailing slash)

$admin_dir = 'http://www.imagefolio.com/clients/cgi-bin/admin';

# (7) ###################################################################
# WHAT IS THE FULL PATH TO YOUR data DIRECTORY?
# The permissions must be set to 777 on this directory as the admin script
# writes the captions and links files here. (no trailing slash)

$data_directory = '/home/httpd/html/www.imagefolio.com/clients/cgi-bin/data';

# (8) ###################################################################
# WHAT IS THE FULL PATH TO YOUR templates DIRECTORY?
# Type the full path below. (no trailing slash)

$template_directory = '/home/httpd/html/www.imagefolio.com/clients/cgi-bin/templates';

# (9) ###################################################################
# WHAT IS THE URL TO THE if_images DIRECTORY?
# This should contain the new, home, next, previous images, as well as the
# images that imageFolio uses in the administration area.  You must NOT
# place this in your $image_directory as defined above, but rather in a
# completely separate directory. (no trailing slash)

$if_images_directory = 'http://www.imagefolio.com/clients/if_images';

# (10) ##################################################################
# WHAT IS THE UNIQUE PATTERN YOU USE TO IDENTIFY THUMBNAIL IMAGES?
# imageFolio will scan a directory for thumbnail images by looking for this
# unique pattern at the beginning of your thumbnail image filename.  If it
# finds this pattern in a filename, it will display the image as a thumbnail
# image.  imageFolio will then check to see if there is another image in
# the same directory, that has the same name, but without the pattern.  If
# it finds a match, it will create a link from the thumbnail image to the
# larger image.  Type the unique pattern you will use for thumbnail filenames
# below.  Remember, you must use this pattern for all thumbnail images and
# it must be placed at the beginning of the image filename (i.e. 
# "tn_image6.gif" and your unique pattern is "tn_"

$mypattern = 'tn_';

# (11) ##################################################################
# WHAT FONT, COLOR, AND SIZE WOULD YOUR LIKE TO USE TO DISPLAY THE
# CATEGORIES AND SUBCATEGORIES?
# the columned category list is the default or main page - category
# names are determined by your directory names. Backslash quote signs!

$cat_font = 'font face="Arial,Helvetica" color="#000000" size=3';

# (12) ##################################################################
# WHAT BACKGROUND COLOR WOULD YOU LIKE TO USE FOR THE SUBCATEGORY HEADER?
# this is the table that displays contains the text "Subcategories"

$category_background_color = '#000000';

# (13) ##################################################################
# WHAT FONT, COLOR, AND SIZE WOULD YOUR LIKE TO USE TO DISPLAY THE
# SUBCATEGORY TITLE ON THE IMAGE PAGES?
# the columned subcategory list is the default or main page - category
# names are determined by your directory names. Backslash quote signs!

$img_cat_font = 'font face="Arial,Helvetica" color="#FFCC00" size="+1"';

# (14) ##################################################################
# WHAT BACKGROUND COLOR WOULD YOU LIKE TO USE FOR THUMBNAIL INFORMATION?
# this is the table that displays image information

$table_background_color = '#eeeeee';

# (15) ##################################################################
# WHAT FONT, COLOR, AND SIZE WOULD YOUR LIKE TO USE TO DISPLAY IMAGE
# INFORMATION AND PAGE LOCATION?

$font = 'font face="Verdana,Arial,Helvetica" color="#000000" size=1';

# (16) ##################################################################
# HOW MANY COLUMNS DO YOU WANT FOR IMAGE DISPLAY? (choose 1,2,3,4,5,6)
# Choose a number between 1 and 6.  Note, for large numbers you might
# consider changing $display_fileinfo to "0".

$columns = 4;

# (17) ##################################################################
# WHAT BACKGROUND COLOR DO YOU WANT THE TABLE TO BE ON THUMBNAIL PAGES?
# white (#ffffff) is default for $thumb_table_bgcolor

$thumb_table_bgcolor = '#ffffff';

# (18) ##################################################################
# WHAT BORDER COLOR DO YOU WANT SURROUND THE IMAGES AND IMAGE INFO?
# gray (#cccccc) is default for $thumb_table_border_color

$thumb_table_border_color = '#cccccc';

# (19) ###################################################################
# HOW WOULD YOU LIKE THE IMAGE TO BE ALIGNED WITHIN THE IMAGE TABLE
# left = aligns image at far left of table
# right = aligns image at far right of table
# center = aligns image in center of table

$image_alignment = 'center';

# (20) ###################################################################
# DO YOU WANT TO DISPLAY FILE INFORMATION AT ALL?
# 1 = Yes, 0 = No (Choose 1 or 0)

$display_fileinfo = 1;

# (21-24) ################################################################
# WHAT INFO DO YOU WISH TO DISPLAY FOR FILE INFORMATION?
# 1 = Yes, 0 = No (Choose 1 or 0)

$display_filename = 1;
$display_filetype = 0;
$display_filesize = 0;
$display_date     = 0;

# (25) ###################################################################
# DO YOU WANT TO PROTECT YOUR IMAGES FROM BEING EASILY STOLEN?
# Note: this is not fullproof.  They can be stolen if the visitor takes a
# snapshot or screenshot of the page, but that would be rare.
# 1 = Yes, 0 = No (Choose 1 or 0)

$protect_images = 1;

# (26) ###################################################################
# WHAT MESSAGE WOULD YOU LIKE TO DISPLAY WHEN SOMEONE TRIES TO STEAL AN
# AN IMAGE FROM YOUR PAGE? this is a javascript alert message.

$protection_message = "This Image is Copyright Protected.";

# (27) ###################################################################
# DO YOU WANT TO DISPLAY IMAGE COUNTS NEXT TO THE CATEGORY AND SUBCATEGORY
# NAMES? (if No, then skip the next question)
# 1 = Yes, 0 = No (Choose 1 or 0)

$display_counts =  1;

# (28) ###################################################################
# WHAT FONT TYPE, COLOR, AND SIZE WOULD YOU LIKE TO USE TO DISPLAY IMAGE
# COUNTS?

$count_font = 'font face="Verdana,Arial,Helvetica" color="#000000" size=1';

# (29) ###################################################################
# DO YOU WISH TO PLACE A "NEW" IMAGE NEXT TO A CATEGORY IF IT HAS BEEN
# MODIFIED IN THE PAST X NUMBER OF DAYS? 1 = Yes, 0 = No (Choose 1 or 0)

$use_new_image = 1;

# (30) ###################################################################
# HOW MANY DAYS OLD IS CONSIDERED NEW?(see above, default is 10)
# Mod Idea - see if you can modify the script to display three
# different new images depending on how many days old.

$new_date = 60;        # specify a number in days

# (31) ###################################################################
# HOW MANY IMAGES DO YOU WANT TO LIST PER PAGE PER CATEGORY AND ON SEARCH
# RESULTS IF USING THE SEARCH MOD?
# Type a number below.

$numtolist = 8;

# (32) ###################################################################
# WHAT ALT TEXT WOULD YOU LIKE TO USE FOR THUMBNAIL IMAGES?
# When the user moves his/her mouse over a thumbnail image, a text message
# can be displayed.  What message would you like that to be:

$alt_text = "Large View";


# (33) ###################################################################
# DO YOU WISH TO DISPLAY THUMBNAIL CAPTIONS?
# 1 - Use thumbnail captions, 0 - Do not use thumbnail captions

$display_thumbcaption = 1;


# (34) ###################################################################
# DO YOU WANT TO USE THE AUTOMATED SLIDESHOW FEATURE?
# ImageFolio can now act as an automated and/or manual slideshow on your
# full-size image pages.  1 - Use auto slideshow, 0 - Don't use it

$auto_slideshow = 1;


# (35) ###################################################################
# HOW OFTEN DO YOU WANT TO ROTATE YOUR SLIDESHOW IMAGES?
# ImageFolio can now act as an automated and/or manual slideshow on your
# full-size image pages.  The speed of the slideshow is determined by the
# number of seconds you define below.  If you want to use the slideshow
# you must place this tag %%%SLIDESHOW%%% after the </title> tag in your
# image.html template file.  If you don't want it, remove that same tag.

$ss_refresh = 10;

# (36) ###################################################################
# WHAT URL SHOULD IMAGEFOLIO USE FOR ITS HOME PAGE?
# Some people like to create their own 'home' pages instead of using
# ImageFolio's built-in dynamic home page.  Creating your own allows you
# to design the page any way you would like, with pictures, category
# descriptions, etc.  The best way to create one is to first use the
# default value below, then later, after you have added all your categories
# view the source for the default home page, copy it, and make your own.
# if not using the default, this should start with http://

$homelink = "$imagefolio_url";


# (37) ###################################################################
# WHAT TYPES OF FILE EXTENSIONS CAN YOUR THUMBNAILS LINK TO
# Leave as is if you don't understand it!
#
# Explanation...
# extension     - this is the file extension without the dot
# type          - what you would like to call this type of file
# link          - use HTML template (1) or link directly to file (0)
# tag           - what HTML tag would you like to use to show this file
# target        - what is the target to use for your href tag
#
# This is a bit tricky, the format is:
#    Extension => ['Type',          link,   'tag',  'target'],
#
# And an example is:
#    jpg       => ['JPEG Image',       1,   'img',  '_blank'],

%extensions = ( 
     jpg       => ['JPEG Image',       1,   'img',    '_top'],
     JPG       => ['JPEG Image',       1,   'img',    '_top'],
     gif       => ['GIF Image',        1,   'img',    '_top'],
     GIF       => ['GIF Image',        1,   'img',    '_top'],
     rm        => ['Real Movie',       0,   'embed',  '_top'],
     RM        => ['Real Movie',       0,   'embed',  '_top'],
     mpg       => ['MPEG Movie',       1,   'embed',  '_top'],
     MPG       => ['MPEG Movie',       1,   'embed',  '_top'],
     mpeg      => ['MPEG Movie',       1,   'embed',  '_top'],
     MPEG      => ['MPEG Movie',       1,   'embed',  '_top'],
     avi       => ['AVI Movie',        1,   'embed',  '_top'],
     AVI       => ['AVI Movie',        1,   'embed',  '_top'],
     mov       => ['QuickTime Movie',  0,   'embed',  '_top'],
     MOV       => ['QuickTime Movie',  0,   'embed',  '_top'],
     zip       => ['Zip File',         0,   '',       '_top'],
     ZIP       => ['Zip File',         0,   '',       '_top'],
     png       => ['PNG Image',        1,   'img',    '_top'],
     PNG       => ['PNG Image',        1,   'img',    '_top']
);


# NO NEED TO MODIFY ANYTHING BELOW THIS LINE #############################

# templates ##########
$thumb_template = $template_directory . "/thumbnail.html";
$home_template = $template_directory . "/home.html";
$image_template = $template_directory . "/image.html";
$search_template = $template_directory . "/search.html";
$new_template = $template_directory . "/new.html";
$random_template = $template_directory . "/random.html";

# images #############
$new_image = $if_images_directory . "/new.gif";
$home_image = $if_images_directory . "/home.gif";
$next_image = $if_images_directory . "/next.gif";
$previous_image = $if_images_directory . "/previous.gif";
$newlyadd_image = $if_images_directory . "/newly_added.gif";
$random_image = $if_images_directory . "/random.gif";
$slide_image = $if_images_directory . "/slideshow.gif";

# databases ##########
$indexfile = $data_directory . "/index.txt";
$catfile = $data_directory . "/categories.txt";

# administration #####
$buildurl = $admin_dir . "/build.cgi";
$adminurl = $admin_dir . "/admin.cgi";


# END OF CONFIGURATION ########################################################


1;