#!/usr/bin/perl

###############################################################################
# imageFolio.cgi                                                              #
###############################################################################
#
# ImageFolio v 2.1 by BizDesign, Inc.
# written by Greg Raaum, webmaster@imageFolio.com
# Available from http://www.ImageFolio.com
# ---------------------------------------------------------------------------
# PROGRAM NAME : ImageFolio 2.1
# VERSION : 2.1
# LAST MODIFIED : 04/17/2000
# ===========================================================================
# COPYRIGHT NOTICE :
#
# Copyright (c) 1999-2000 BizDesign, Inc. All Rights Reserved.
# Selling the code for this program without prior written consent is
# expressly forbidden.
#
# Obtain written permission before redistributing this software over the 
# Internet or in any other medium.  In all cases copyright and header must
# remain intact.
#
# Feel free to modify the code of this program to suit your likings. 
#
# Although this program has been thoroughly tested on BizDesign's servers, we
# do not warrant that it works on all servers and will not be held liable
# for anything, including but not limited to, misusage, error, or loss of data.
#
# Use at your own risk!
###############################################################################

# Do not modify below this line unless you know what you are doing.
###############################################################################


eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows

    require "config.pl";               # Change this to full path to config.pl if you have problems.
    &top;
};

if ($@) { print "Content-type: text/plain\n\nError including configuration file: $@\n"; }
exit;

###############################################################################
# TOP
# Determines what to do
###############################################################################
sub top {
   $|++;   # flush output
   $incoming = $ENV{'QUERY_STRING'};
   @pairs = split(/&/, $incoming);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $FORM{$name} = $value;
   }

   &parse_form;
   &load_values;

   if ($FORM{'action'} eq "view") { &view_image; }
   elsif ($FORM{'direct'}) { &gen_image_table; }
   else { &gen_home_page; }
}

###############################################################################
# GEN IMAGE TABLE
# Makes the all important table containing images and image data
###############################################################################
sub gen_image_table {

   if ($FORM{'direct'} =~ /\.\./) {
      print "Content-type: text/html\n\n";
      print qq|<br><br><center><font face="Verdana,Arial,Helvtica" size=2>
      You are not allowed to use <b>../</b> as a directory.<br>
      <a href="$ENV{'HTTP_REFERER'}"><b>Return to Previous
      Page</b></a></font></center><br><br>|;
      exit;
   }

   if ( (!(-e "$image_directory/$FORM{'direct'}")) || (!(-d "$image_directory/$FORM{'direct'}")) ) {
      print "Content-type: text/html\n\n";
      print qq|<br><br><center><font face="Verdana,Arial,Helvtica" size=2>
      <font color="red"><b>Error!</font>  $FORM{'direct'}</b> is not
      a valid category! Please try again.<br><br><a
      href="$ENV{'HTTP_REFERER'}"><b>Return to Previous
      Page</b></a></font></center><br><br>|;
      exit;
   }

# load everything into memory, then print it out

   if ($protect_images eq "1") { &protect; }
   &build_pull_down_menu;
   &parse_image_directory;
   &build_subcategory_list;
   &build_thumbnail_table;
   &build_nextprev_links;
   &build_nav;
   $pagelinks = build_title_linked($FORM{'direct'});


   if (-e "$image_directory/$FORM{'direct'}/thumbnail.html") {
      open (TEMPLATE,"$image_directory/$FORM{'direct'}/thumbnail.html") || die "Content-type: text/html\n\nCould not open template.  Reason $! \n";
   }
   else {
      open (TEMPLATE,"$thumb_template") || die "Content-type: text/html\n\nCould not open template.  Reason $! \n";
   }
   while (<TEMPLATE>) {
      if (/<!--#include\s+(virtual|file)\s*=\s*"*([^"\s]*)"*\s*-->/i) { $template .= &ssi_include($2); }
      else { $template .= $_; }
   }
   close(TEMPLATE);

   $template =~ s/%%%PULLDOWN_MENU%%%/$pulldown_menu/ig;
   $template =~ s/%%%SEARCH_BOX%%%/$search_box/ig;
   $template =~ s/%%%NAV%%%/$nav/ig;
   $template =~ s/%%%CATEGORY%%%/$newthisdirectory/ig;
   $template =~ s/%%%PAGELINKS%%%/$pagelinks/g;
   $template =~ s/%%%SUBCATEGORIES%%%/$subcatlinks/ig;
   $template =~ s/%%%PREVIOUS_CATEGORY%%%/$previous_category/ig;
   $template =~ s/%%%NEXT_CATEGORY%%%/$next_category/ig;
   $template =~ s/%%%PREVIOUS_PAGE%%%/$prevpage/ig;
   $template =~ s/%%%SITE_TITLE%%%/$site_title/ig;
   $template =~ s/%%%PROTECT%%%/$protection/ig;
   $template =~ s/%%%IFIMAGES%%%/$if_images_directory/ig;

   if ($totalnames >= 1) { $template =~ s/%%%THUMBNAILS%%%/$thumbimages/ig; }
   else { $template =~ s/%%%THUMBNAILS%%%//ig; }

   if ($totalnames > $numtolist) {
      $template =~ s/%%%PAGES_LINKED%%%/$nextlinks/ig;
      $template =~ s/%%%NEXT_PAGE%%%/$nextpage/ig;
      $template =~ s/%%%SEARCH_INFO%%%/$pageinfo/ig;
   }
   else {
      $template =~ s/%%%PAGES_LINKED%%%//ig;
      $template =~ s/%%%NEXT_PAGE%%%//ig;
      $template =~ s/%%%SEARCH_INFO%%%//ig;
   }

   print "Content-type: text/html\n\n";
   print $template;
}

###############################################################################
# BUILD THUMBNAIL TABLE
# build $numtolist thumbnails on a page by reading the array names
###############################################################################
sub build_thumbnail_table {

######
   @thumbcaps = ();
   $newlink  = $FORM{'direct'};
   $newlink  =~ s/\//\./g;
   $newlink = "$data_directory/$newlink.tcaptions.txt";

   if (-e $newlink && $display_thumbcaption) {
   open (CAPTIONS,"< $newlink");
      while (<CAPTIONS>) {
         chomp;
         push(@thumbcaps, $_);
      }
   close(CAPTIONS);
   }

#########

$thumbimages .= qq|<tr bgcolor="$thumb_table_border_color"><td valign=top align=center>
<table border="0" cellspacing=1 cellpadding=4 width="100%">|;

   my ($i, $count);
   my $img = $FORM{'img'};
   my($most) = $img + $numtolist;
   $SIZE=@names;
   if ($most > $SIZE) { $most = $SIZE; }

   for ($cnt=$img; $cnt < $most; $cnt++) {
      $name = ($names[$cnt]);


      if ($count==0){ $thumbimages .= qq|<tr bgcolor="$thumb_table_bgcolor">|; }

      ($linkimage) = $name =~ m,^(.*)\.\w+$,;
      $linkimage =~ s/$mypattern//g;
      $thumbcaption = "";



      if (-e $newlink && $display_thumbcaption) {
         $tshortname = $linkimage;
         foreach $thumbcap(@thumbcaps) {
            my($image_filename, $tcaption) = split(/\t/, $thumbcap);
            next if !$tcaption;
            ($new_image_filename) = $image_filename =~ m,^(.*)\.\w+$,;
            if ($new_image_filename eq $tshortname) {
               $thumbcaption = $tcaption . "<br>";
               last;
            }
         }
      }

      foreach $key (keys %extensions) {
         if ( -e "$image_directory/$FORM{'direct'}/$linkimage.$key" ) {
            $if_filetype =  $extensions{$key}[0];
            $if_link     =  $extensions{$key}[1];
            $if_tagtype  =  $extensions{$key}[2];
            $if_target   =  $extensions{$key}[3];
            $linkimage   =  $linkimage . ".$key";
            $clink       =  qq|</a>|;
            $newname     =  $linkimage;
            $file_type   =  $if_filetype;
            $extfound    =  1;
            ($filesize, $filedate) = (stat($linkimage))[7,9];   #get size, timestamp
            $filedate = &unix_to_date($filedate);               #convert unix time to a legible day

            if ($if_link == 1) {
               $slink =  qq|<a href="$ENV{'SCRIPT_NAME'}?action=view&link=$FORM{'direct'}&image=|;
               $slink .= qq|$linkimage&img=$FORM{'img'}&tt=$if_tagtype" target="$if_target">|;
            }
            else {
               $slink = qq|<a href="$imageurl/$FORM{'direct'}/$linkimage" target="$if_target">|;
            }
            last;
         }
      }

      if (!$extfound) {
         ($filesize, $filedate) = (stat($name))[7,9];        #get size, timestamp
         $filedate = &unix_to_date($filedate);               #convert unix time to a legible day
         $slink = "";
         $clink = "";
         $file_type = "Not Found!";
         $newname = $name;
      }

      if ($filesize < 1500) { $filesize = commify($filesize) . " bytes"; }
      else { $filesize = int($filesize/1000) . " Kb"; }

      &show_thumbnail;
      $count++;

      if ($count==$columns) {
         $thumbimages .= qq|</tr>|;
         $count=0;
      }

      $i++;
   }        #end of foreach

   if ($count>0)  {
      $leftover = ($columns - $count);
      if ($leftover >=1 ) {
         $thumbimages .= qq|<td>&nbsp;</td>| x $leftover;
         $thumbimages .= qq|</tr>|;
      }
   }
   $thumbimages .= qq|</table></td></tr>|;
}

###############################################################################
# PARSE IMAGE DIRECTORY
# navigate to the image directory and read in all files and subdirectories
###############################################################################
sub parse_image_directory {

   chdir(IMAGEDIR,"$image_directory/$FORM{'direct'}");
   opendir(IMAGEDIR,"$image_directory/$FORM{'direct'}")|| die("Error Reading Directory:", "$!");
   @files = readdir(IMAGEDIR);
   @files = sort { lc($a) cmp lc($b) } @files;               # sort the file names alphabetically
   @subdirectories = ();                                     # declare the subdirectories array
   @newnames = ();                                           # declare the thumbnails array
   @othernames = ();                                         # declare the thumbnails array
   @names = ();                                              # declare the thumbnails array

   foreach $file (@files) {
      if ( -d "$image_directory/$FORM{'direct'}/$file" ) {   # make sure this really is a directory
         chop $file if ($file =~ /\/$/);
         next if $file =~ /^\.\.?$/;                         # weed out all .. directories
         next if $file =~ /_vti_cnf/i;                       # weed out front page directories
         push(@subdirectories, $file);                       # put the subdirectories in an array
         $found = "1";                                       # if we found a good directory
      }
      else{
         if ( -B $file && $file =~ /$mypattern/i ) {         # if this is a thumbnail and binary file
            if (-M "$image_directory/$FORM{'direct'}/$file" <= $new_date) { push(@newnames, $file); }
            else { push(@othernames, $file); }
            $totalnames++;                                   # count all of the thumnails found
         }
      }
   }
   closedir(IMAGEDIR);

   push(@names, @newnames);   # first push the new images onto the names array
   push(@names, @othernames); # next push everthing else onto the names array
}

###############################################################################
# BUILD SUBCATEGORY LIST
# if subdirectories were found, we build a 2 column linked list of those found
###############################################################################
sub build_subcategory_list {

   unless (!$found) {
      my ($cathalf) = int (($#subdirectories+2) / 2);     # for splitting subcats into 2 columns

$subcatlinks = qq|<tr bgcolor="$category_background_color"><td>
<table border="0" width="100%" cellspacing=0 cellpadding=4><tr>
<td align="$pagelinks_alignment"><$img_cat_font><b>Subcategories</b></font></td>
</tr></table></td></tr><tr bgcolor="#ffffff"><td valign=top>
<table border="0" width="100%" cellspacing=0 cellpadding=6><tr><td valign=top>
|;

      open (FILE,"$catfile");
      my(@LINES)=<FILE>;
      close(FILE);
      chomp @LINES;

      foreach $directory (@subdirectories) {
         $ttcount = 0;
         $mydirectory = &get_clean_name ($directory);     #remove underscores and replace slashes
         $catmatch = $FORM{'direct'} . "/$directory";

         if ($i == $cathalf) { $subcatlinks .= qq|</td><td valign="top">|; }

         if ($use_new_image) {
            if ($FORM{'direct'}) {
               if (-M "$image_directory/$catmatch" <= "$new_date") { 
                  $if_new = "<img src=\"$new_image\" border=0 alt=\"New\">"; }
               else { $if_new = ""; }
            }
            else {
               if (-M "$image_directory/$directory" <= "$new_date") { 
                  $if_new = "<img src=\"$new_image\" border=0 alt=\"New\">"; }
               else { $if_new = ""; }
            }
         }

         if ($display_counts eq "1") {
            foreach $LINE (@LINES) {
               ($category, $totalcount) = split(/\t/, $LINE);
               if ($category eq $catmatch || $LINE =~ /^$catmatch\//) { $ttcount += $totalcount; }
            }
            $imagecount = qq|<$count_font>($ttcount)</font> |;
         }

      $subcatlinks .= qq|<table border=0 cellspacing=1 cellpadding=3 width="100%">
      <tr><td><$cat_font><li><strong><a href="$ENV{'SCRIPT_NAME'}\?direct=$FORM{'direct'}/$directory">$mydirectory</a></strong>
      $imagecount$if_new</li></font></td></tr></table>
      |;

         $i++;
         $imagecount = "";
      }          # end of foreach

   $subcatlinks .= qq|</td></tr></table></td></tr>|;
   }
}

###############################################################################
# SHOW THUMBNAIL
# this is where we show what each thumbnail will look like
# called from gen_image_table
###############################################################################
sub show_thumbnail {

   ($shortname) = $newname =~ m,^(.*)\.\w+$,;

   if ($display_fileinfo eq "1") { $thumbalign = "bottom"; }
   else { $thumbalign = "center"; }

$thumbimages .= qq|<td valign="$thumbalign" width="$imgtable_width">
<table border=0 cellspacing=1 cellpadding=4 width="100%"><tr>
<td align="$image_alignment">$slink<img
src="$imageurl/$FORM{'direct'}/$name"border=0 alt="$alt_text">$clink|;

   if ($display_fileinfo eq "1") {
      $thumbimages .= qq|</td></tr><tr><td valign=top bgcolor="$table_background_color"><$font>|;
      if ($display_filename eq "1")                     { $thumbimages .= qq|<b>$shortname</b><br>|;  }
      if ($display_thumbcaption)                        { $thumbimages .= qq|$thumbcaption|; }
      if ($display_filetype eq "1")                     { $thumbimages .= qq|$file_type<br>|; }
      if ($display_filesize eq "1")                     { $thumbimages .= qq|Size: $filesize<br>|;  }
      if ($display_date eq "1")                         { $thumbimages .= qq|Added: $filedate<br>|; }
      $thumbimages .= qq|</font>|;
   }

$thumbimages .= qq|</td></tr></table></td>|;
}

###############################################################################
# BUILD NEXTPREV LINKS
# Generate links to additional image pages and next/previous links if necessary
###############################################################################
sub build_nextprev_links {

$num = $totalnames;
$calc = int(($num / $numtolist) + '0.99');
if (!$numtolist) { $numtolist = 10; }
$base = $numtolist;

   if (!$FORM{'img'} || $FORM{'img'} eq "0") {
      $FORM{'img'} = "0";
      $nextfactors = $numtolist;
      $nextlinks .= qq|(<b>1</b>)&nbsp;&nbsp;|;
      $thisfactor = 1;
   }

   foreach $linkpage (2..$calc) {
      $factors = (($base * $linkpage) - $base);
      if ($FORM{'img'} == $factors) {
         $thisfactor = $linkpage;
      }
      push(@factorials, $linkpage);
   }

   $numpage_links = @factorals;
   $leftpos1 = $thisfactor - 3;
   $leftpos2 = $thisfactor - 2;
   $leftpos3 = $thisfactor - 1;
   $righpos1 = $thisfactor + 1;
   $righpos2 = $thisfactor + 2;
   $righpos3 = $thisfactor + 3;
   $nextfactor = $righpos1;
   $nextfactors = (($base * $nextfactor) - $base);
   $prevfactor = $leftpos3;
   $prevfactors = (($base * $prevfactor) - $base);

   foreach $factor (@factorials) {
      $factors = (($base * $factor) - $base);
      if ($factor == $leftpos1) { $leftlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=$factors">$factor</a></b>&nbsp;&nbsp;|; }
      if ($factor == $leftpos2) { $leftlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=$factors">$factor</a></b>&nbsp;&nbsp;|; }
      if ($factor == $leftpos3) { $leftlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=$factors">$factor</a></b>&nbsp;&nbsp;|; }
      if ($factor == $thisfactor) { $currentpage .= qq|(<b>$thisfactor</b>)&nbsp;&nbsp;|;
      if ($factor <= 4) { $pageone = qq|<b><a href="$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=0">1</a></b>&nbsp;&nbsp;|; }}
      if ($factor == $righpos1) { $rightlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=$factors">$factor</a></b>&nbsp;&nbsp;|; }
      if ($factor == $righpos2) { $rightlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=$factors">$factor</a></b>&nbsp;&nbsp;|; }
      if ($factor == $righpos3) { $rightlinks .= qq|<b><a href="$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=$factors">$factor</a></b>&nbsp;&nbsp;|; }
      $lastfactor = $factor;
  }

   $nextlinks .= $pageone . $leftlinks . $currentpage . $rightlinks;

   if ($lastfactor > $thisfactor) {
      $next_page_link = "$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=$nextfactors";
      $nextpage = qq|<a href="$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=$nextfactors">Next
      [&gt;&gt;]</a>|;
   }
   else {
      $next_page_link = "";
      $nextpage = "";
   }

   if (!$FORM{'img'} || $FORM{'img'} eq "0") {
      $previous_page_link = "";
      $prevpage = "";
   }
   else {
      $previous_page_link = "$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=$prevfactors";
      $prevpage = qq|<a href="$ENV{'SCRIPT_NAME'}?direct=$FORM{'direct'}&img=$prevfactors">[&lt;&lt;]
      Prev</a>&nbsp;&nbsp;|;
   }

   if ($num > $numtolist) { $page = "pages"; }
   else { $page = "page"; }

   if ($most = $SIZE) {
      $pageinfo = qq|$num images found on $calc $page.<br>
      Displaying $numtolist images per page.</b><br>|;
   }

}

###############################################################################
# VIEW IMAGE
# Generates a page showing one image.  Results from the click on a linked
# thumbnail image.  The header and footer files used here are different than
# the ones for thumbnail pages generated by gen_image_table.
###############################################################################
sub view_image {

    if (!$FORM{'tt'}) { $FORM{'tt'} = "img"; }
     $newlink = $FORM{'link'};
     $newlink =~ s/\//\./g;
     ($newimage) = $FORM{'image'} =~ m,^(.*)\.\w+$,;

   if ($FORM{'search'}) {
     if ($FORM{'search'} eq "NEW")       { $searchphrase = "Newly Added"; }
     elsif ($FORM{'search'} eq "RANDOM") { $searchphrase = "Random Display"; }
     else                                { $searchphrase = "Search Results"; }

     $searchinfo = qq|Displaying $newimage from $newthisdirectory|;

     $newthisdirectory = $searchphrase;

     $fullsize_image = qq|<a href="$imagesearch_url?search=$FORM{'search'}&img=$FORM{'img'}"><$FORM{'tt'}
     src="$imageurl/$FORM{'link'}/$FORM{'image'}" border=0 alt="$FORM{'image'}"></a>|;

      $pagelinks = qq| <$font><A HREF="$homelink">Top</A> &gt;
      <a href="$imagesearch_url?search=$FORM{'search'}&img=$FORM{'img'}&cat=$FORM{'cat'}">$searchphrase</a>
      &gt; $newimage</font>|;
   }
   else {
      &get_nextprev_image_links;
      $pagelinks = build_title_linked($FORM{'link'});
      $fullsize_image = qq|<a href="$ENV{'SCRIPT_NAME'}\?direct=$FORM{'link'}&img=$FORM{'img'}"><$FORM{'tt'}
      src="$imageurl/$FORM{'link'}/$FORM{'image'}" border=0 alt="$FORM{'image'}"></a>|;
   }

   if ($FORM{'tt'} eq "embed") { $fullsize_image .= qq|</embed>|; }

   if (-e "$data_directory/$newlink.captions.txt"){
      open (CAPTIONS,"$data_directory/$newlink.captions.txt");
      while (<CAPTIONS>) {
         my($filename, $description) = split(/\t/,$_);
         chomp $_;
         next if !$description;
         ($newfile) = $filename =~ m,^(.*)\.\w+$,;
         if ($newfile eq $newimage) {
            $image_caption = $description;
            last;
         }
      }
      close(CAPTIONS);
   }

   if ($protect_images eq "1") { &protect; }
   &build_pull_down_menu;
   &build_nav;

   if (-e "$image_directory/$FORM{'link'}/image.html") {
      open (TEMPLATE,"$image_directory/$FORM{'link'}/image.html") || die "Content-type: text/html\n\nCould not open template.  Reason $! \n";
   }
   else {
      open (TEMPLATE,"$image_template") || die "Content-type: text/html\n\nCould not open template.  Reason $! \n";
   }

   while (<TEMPLATE>) {
      if (/<!--#include\s+(virtual|file)\s*=\s*"*([^"\s]*)"*\s*-->/i) { $template .= &ssi_include($2); }
      else { $template .= $_; }
   }
   close(TEMPLATE);

   $template =~ s/%%%SITE_TITLE%%%/$site_title/ig;
   $template =~ s/%%%IMAGE%%%/$fullsize_image/ig;
   $template =~ s/%%%CAPTION%%%/$image_caption/ig;
   $template =~ s/%%%RATINGS_URL%%%/$ratings_url/ig;
   $template =~ s/%%%NAV%%%/$nav/ig;
   $template =~ s/%%%PROTECT%%%/$protection/ig;
   $template =~ s/%%%IMAGE_NAME%%%/$newimage/ig;
   $template =~ s/%%%SLIDESHOW%%%/$slideshow_tag/ig;
   $template =~ s/%%%CATEGORY%%%/$newthisdirectory/ig;
   $template =~ s/%%%SEARCH_INFO%%%/$searchinfo/ig;
   $template =~ s/%%%PAGELINKS%%%/$pagelinks/ig;
   $template =~ s/%%%PULLDOWN_MENU%%%/$pulldown_menu/ig;
   $template =~ s/%%%SEARCH_BOX%%%/$search_box/ig;
   $template =~ s/%%%PREVIOUS_CATEGORY%%%/$previous_category/ig;
   $template =~ s/%%%NEXT_CATEGORY%%%/$next_category/ig;
   $template =~ s/%%%THUMB_LINK%%%/$thumblinks/ig;
   $template =~ s/%%%IFIMAGES%%%/$if_images_directory/ig;

print "Content-type: text/html\n\n";
print $template;
}

###############################################################################
# GET NEXTPREV IMAGE LINKS
# called from view_image to provide navigation to next and previous full-size
# images
###############################################################################
sub get_nextprev_image_links {

   chdir(IMAGEDIR,"$image_directory/$FORM{'link'}");
   opendir(IMAGEDIR,"$image_directory/$FORM{'link'}")|| die("Error Reading Directory:", "$!");
   @files = readdir(IMAGEDIR);
   @files = sort { lc($a) cmp lc($b) } @files;
   @newnames = ();
   @othernames = ();
   @names = ();

   foreach $file (@files) {
      if ( -B $file && ($file =~/\.jpg/i ||  $file =~/\.gif/i ||  $file =~/\.png/i)) {
         next if $file =~ /$mypattern/i;
         if (-M "$image_directory/$FORM{'link'}/$file" <= $new_date) { push(@newnames, $file); }
         else { push(@othernames, $file); }
      }
   }
   closedir(IMAGEDIR);

   push(@names, @newnames);   # first push the new images into the names array
   push(@names, @othernames); # next push everthing else into the names array

   $SIZE=@names;
   $current_image = $FORM{'image'};

   $cnt = 0;

   if ($SIZE > 1) {
      foreach $name (@names) {
         if ($name eq $current_image) {
            $thiscount = $cnt + 1;
            $nextcount = ($cnt + 1);
            $prevcount = ($cnt - 1);
            last;
         }
         $cnt++;
      }

   $searchinfo = qq|Displaying image $thiscount of $SIZE|;
   if ($auto_slideshow && $FORM{'slideshow'}) { $searchinfo .= qq|<br>$ss_refresh Second Slideshow Mode|; }
   else { $searchinfo .= qq|<br>Manual Slideshow Mode|; }

   $cnt = 0;

      foreach $name (@names) {
         if ($cnt eq $nextcount) {
            $nextimage = $name;
            $next_page_link =  qq|$ENV{'SCRIPT_NAME'}?action=view&link=$FORM{'link'}&image=$nextimage&img=$FORM{'img'}&tt=$if_tagtype|;
            if ($auto_slideshow && $FORM{'slideshow'}) { $slideshow_tag = qq|<META HTTP-EQUIV="refresh" CONTENT="$ss_refresh ;URL=$ENV{'SCRIPT_NAME'}?action=view&link=$FORM{'link'}&image=$nextimage&img=$FORM{'img'}&tt=$if_tagtype&slideshow=1">|; }
         }
         if ($cnt eq $prevcount) {
            $previmage = $name;
            $previous_page_link =  qq|$ENV{'SCRIPT_NAME'}?action=view&link=$FORM{'link'}&image=$previmage&img=$FORM{'img'}&tt=$if_tagtype|;
         }
         last if $previmage && $nextimage;
         $cnt++;
      }
   }
}


###############################################################################
# SSI INCLUDE
# Funtion to include an external page called via SSI tags
###############################################################################
sub ssi_include {
   my ($includefile) = shift;
   open (EXTERNAL,"$includefile") || die "Content-type: text/html\n\nCould not open $includefile.  You must use an absolute path $! \n";
   my(@filelines)=<EXTERNAL>;
   foreach $fileline (@filelines) { $external .= $fileline; }
   close(EXTERNAL);
   return $external;
}

###############################################################################
# GEN HOME PAGE
# Generated if a category was not selected prior to calling the script
# outputs a page listing all the main categories, in two columns
###############################################################################
sub gen_home_page {

   open (FILE,"$indexfile") || die "Content-type: text/html\n\nCan't Open $indexfile, is it created?: $!\n";
   my(@BLAH)=<FILE>;
   close(FILE);
   $IMAGESIZE = @BLAH;

   $pagelinks = qq| <$font><A HREF="$homelink">Top</A></font>|;
   &build_pull_down_menu;
   $counts = "$IMAGESIZE images in $CATSIZE categories";
   &build_nav;

   open (TEMPLATE,"$home_template") || die "Could not open $home_template.  Reason $! \n";
   while (<TEMPLATE>) {
      if (/<!--#include\s+(virtual|file)\s*=\s*"*([^"\s]*)"*\s*-->/i) { $template .= &ssi_include($2); }
      else { $template .= $_; }
   }
   close(TEMPLATE);

   $template =~ s/%%%PULLDOWN_MENU%%%/$pulldown_menu/ig;
   $template =~ s/%%%SEARCH_BOX%%%/$search_box/ig;
   $template =~ s/%%%CATEGORIES%%%/$columncat/ig;
   $template =~ s/%%%SITE_TITLE%%%/$site_title/ig;
   $template =~ s/%%%COUNTS%%%/$counts/ig;
   $template =~ s/%%%NAV%%%/$nav/ig;
   $template =~ s/%%%PAGELINKS%%%/$pagelinks/ig;
   $template =~ s/%%%IFIMAGES%%%/$if_images_directory/ig;

   print "Content-type: text/html\n\n";
   print $template;
}

###############################################################################
# BUILD PULL DOWN MENU
# Here we read the image directory get a list of directory names
# the names are then put in the @alldirectories
###############################################################################
sub build_pull_down_menu {

$i=0;

$pulldown_menu .= qq|
<form method=post action="$ENV{'SCRIPT_NAME'}">
<table border=0 cellspacing=0 cellpadding=1><tr><td>
<select name="direct">|;

   open (FILE,"$catfile");
   my(@LINES)=<FILE>;
   close(FILE);
   chomp @LINES;
   $CATSIZE = @LINES;

   opendir (DIR, $image_directory) || die ("Error Reading Directory:", "$!");
   @files = readdir(DIR);
   closedir (DIR);
   @files = sort { lc($a) cmp lc($b) } @files;
   @alldirectories = ();

   foreach $file (@files) {
      if ( -d "$image_directory/$file" ) {                   #make sure this really is a directory
         chop $file if ($file =~ /\/$/);
         next if $file =~ /^\.\.?$/;                         #weed out all .. directories
         next if $file =~ /_vti_cnf/i;                       #weed out front page directories
         push(@alldirectories, $file);
      }
   }

my ($half) = int (($#alldirectories+2) / 2) unless $FORM{'direct'};

   foreach $directory (@alldirectories) {
      $ttcount = 0;

      if (@alldirectories[$i] eq $FORM{'direct'} || @alldirectories[$i] eq $FORM{'link'}) {
         if ( -d "$image_directory/@alldirectories[($i+1)]" ) { $nextcat = @alldirectories[($i+1)]; }
         if ( -d "$image_directory/@alldirectories[($i-1)]" ) { $prevcat = @alldirectories[($i-1)]; }
      }

      $mydirectory = $directory;
      $mydirectory =~ s/_/ /g;
      $catlist .= qq|<option value="$directory"> - $mydirectory</option>| unless $directory eq $FORM{'direct'};

      unless ($FORM{'direct'} && $FORM{'link'} && $FORM{'search'}) {
         if ($i == $half) { $columncat .= qq|</td><td valign="top">|; }

         if ($use_new_image) {
            if (-M "$image_directory/$directory" <= "$new_date") {
               $if_new = "<img src=\"$new_image\" border=0 alt=\"New\">";
            }
            else {
               $if_new = "";
            }
         }

        $mydirectory = get_clean_name($directory);

         if ($display_counts eq "1") { 
            foreach $LINE (@LINES) {
               ($category, $totalcount) = split(/\t/, $LINE);
               if (($category eq $directory) || ($category =~ /^$directory\//)) { $ttcount += $totalcount; }
            }
            $imagecount = qq|<$count_font>($ttcount)</font> |;
         }

         $columncat .= qq|<table border=0 cellspacing=1 cellpadding=3 width="100%"><tr><td>
         <$cat_font><li><strong><a href="$ENV{'SCRIPT_NAME'}\?direct=$directory">$mydirectory</a>
         </strong> $imagecount$if_new</li></font></td></tr></table>
         |;

     } # end of unless direct

   $i++;
   $imagecount = "";
   }   # end of foreach

$i=0;

$pulldown_menu .= qq|
$catlist</select></td><td><input type=image src="$if_images_directory/view.gif" border=0></td>
</tr></table></form>|;

if ($FORM{'search'} eq "RANDOM" || $FORM{'search'} eq "NEW") { $searchtag = ""; }
else { $searchtag = $FORM{'search'}; }

$search_box .= qq|<form method=get action="$imagesearch_url" name="SearchForm">
<input type=hidden name="img" value="0">
<table border=0 cellspacing=0 cellpadding=1><tr><td>
<input type=text size=20 maxlength=75 name=search value="$searchtag"></td>
<td><select name=cat>
|;

   if ($FORM{'direct'}) {
      $thiscat = get_category($FORM{'direct'});
      $search_box .= qq|<option value="$FORM{'direct'}" selected>- $thiscat|;
   }

$search_box .= qq|
<option value="all">- All Categories$catlist</select></td>
<td><input type=image src="$if_images_directory/search.gif" border=0></td></tr></table>

<SCRIPT LANGUAGE="JavaScript">
<!-- Script Hiding...
document.SearchForm.search.focus();
// End Hiding -->
</SCRIPT>

</form>
|;

   if ($prevcat) {
      $newprevcat = &get_directory($prevcat);
      $newprevcat = &get_clean_name($newprevcat);
      $previous_category = qq|<$font><nobr>BACKWARD</nobr><br><a
      href="$ENV{'SCRIPT_NAME'}?direct=$prevcat"><b>$newprevcat</b></a></font>|;
   }

   if ($nextcat) {
      $newnextcat = &get_directory($nextcat);
      $newnextcat = &get_clean_name($newnextcat);
      $next_category = qq|<$font><nobr>FORWARD</nobr><br><a
      href="$ENV{'SCRIPT_NAME'}?direct=$nextcat"><b>$newnextcat</b></a></font>|;
   }

}

###############################################################################
# GET CATEGORY
# Returns a string of the search path containing the category broken up 
###############################################################################
sub get_category {
   my $input = shift;
   my (@categories, $output, $path, $last);
   @categories = split (/\//, $input);
   $last = pop @categories;
   $last =~ s/_/ /g;
   $output = $last;
   return $output;
}

###############################################################################
# BUILD NAV
# creates previous, home, and next link buttons if necessary
###############################################################################
sub build_nav {

   if ($previous_page_link) {
      $nav .= qq|<a href="$previous_page_link"><img src="$previous_image" border=0 alt="Previous Page"></a>|;
   }

$nav .= qq|<a href="$homelink"><img src="$home_image" border=0 alt="Return to Home Page"></a>|;
$nav .= qq|<a href="$imagesearch_url?img=0&search=NEW"><img src="$newlyadd_image" border=0 alt="Newly Added"></a>|;
$nav .= qq|<a href="$imagesearch_url?img=0&search=RANDOM"><img src="$random_image" border=0 alt="Random Display"></a>|;

   if ($FORM{'action'} eq "view") {
      if ($FORM{'search'}) {
      $thumblinks .= qq|<a href="$imagesearch_url?search=$FORM{'search'}&img=$FORM{'img'}&cat=$FORM{'cat'}"><b>Return to $searchphrase</b></a><br><a href="$ENV{'SCRIPT_NAME'}\?direct=$FORM{'link'}&img=0"><b>View this Category</b></a><br>|;
      }
      else {
      if ($auto_slideshow && $next_page_link) { $nav .= qq|<a href="$next_page_link&slideshow=1"><img src="$slide_image" border=0 alt="Play Slideshow"></a>|; }
      $thumblinks .= qq|<a href="$ENV{'SCRIPT_NAME'}\?direct=$FORM{'link'}&img=$FORM{'img'}"><b>Return to Thumbnail View</b></a><br>|;
      }
   }

   if ($next_page_link) {
      $nav .= qq|<a href="$next_page_link"><img src="$next_image" border=0 alt="Next Page"></a>|;
   }
}

###############################################################################
# LOAD VALUES
# Establishes default values for commonly used variables
###############################################################################
sub load_values {
my ($found, $i, $pos, $count, $cnt, $nav, $subcatlinks, $thumbimages);

   if ($FORM{'direct'}) {
      $thisdirectory = get_directory($FORM{'direct'});
      $newthisdirectory = get_clean_name($thisdirectory);
      $imgtable_width = int (100 / $columns);
      $imgtable_width .= "%";
   }
   elsif ($FORM{'link'}) {
      $thisdirectory = get_directory($FORM{'link'});
      $newthisdirectory = get_clean_name($thisdirectory);
   }
}

###############################################################################
# UNIX TO DATE
# Takes in a unix time and coverts it to legible form
###############################################################################
sub unix_to_date {
   my $time   = shift;
   my ($sec, $min, $hour, $day, $mon, $year, $dweek, $dyear, $tz) = localtime $time;
   my @months = qw!01 02 03 04 05 06 07 08 09 10 11 12!;
   $year += 1900;
   return "$months[$mon]/$day/$year";
}

###############################################################################
# COMMIFY
# puts commas in those large numbers
###############################################################################
sub commify {
   my $text = reverse $_[0];
   $text =~ s/(\d\d\d)(?=\d)(?!\d*\.)/$1,/g;
   return scalar reverse $text;
}

###############################################################################
# BUILD TITLE LINKED
# Returns a string of the current category broken up 
# by section, with each part linked to the respective section.
###############################################################################
sub build_title_linked {
   my $input = shift;
   my (@categories, $cat, $output, $path, $last);
   @categories = split (/\//, $input);
   $i=0;
   $last = get_clean_name(pop @categories);
   $output = qq| <$font><A HREF="$homelink">Top</A> &gt;</font>|;

   foreach $cat (@categories) {
      if ($i < 1) { $path .= "$cat"; }
      else { $path .= "/$cat"; }
      $cat = get_clean_name($cat);
      $output .= qq| <$font><A HREF="$ENV{'SCRIPT_NAME'}\?direct=$path">$cat</A> &gt;</font>|;
      $i++;
   }

   if ($FORM{'direct'}) {
      if ($totalnames > $numtolist) {
         if ($FORM{'img'}) { $imagecount = $FORM{'img'}; }
         else { $imagecount = "0"; }
         $pagenumber = int($imagecount / $numtolist);
         $pagenumber++;
         if ($pagenumber eq "1") { $output .= " <$font>$last</font>"; }
         else {
         $output .= qq| <$font><A HREF="$ENV{'SCRIPT_NAME'}\?direct=$FORM{'direct'}">$last</A>
         &gt; Page $pagenumber</font>|;
         }
      }
      else { $output .= " <$font>$last</font>"; }
   }
   elsif ($FORM{'link'}) {
      $output .= qq| <$font><a href="$ENV{'SCRIPT_NAME'}\?direct=$FORM{'link'}&img=$FORM{'img'}">$last</a> &gt; $newimage</font>|;
   }

return $output;
}

###############################################################################
# GET DIRECTORY
# Returns a string of the current category broken up 
# Returns a string containing the current directory
###############################################################################
sub get_directory {
   my $input = shift;
   my (@categories, $cat, $output, $path, $last);
   @categories = split (/\//, $input);
   $last = pop @categories;
   $output = $last;
   return $output;
}

###############################################################################
# Get Clean Name
# Formats a category name for displaying.
###############################################################################
sub get_clean_name {
   my ($input) = shift;
   $input =~ s/_/ /g;      # Change '_' to spaces.
   $input =~ s,/, : ,g;    # Change '/' to ' : '.
   return $input;
}

###############################################################################
# PROTECT
# called from print_image_table if image protection is turned on.  Generates a
# javascript that presents the site visitor with an alert message if the right
# mouse button is used on the page.  Very simple, but effective.
###############################################################################
sub protect {
$protection = qq|

<!-- Powered by BizDesign ImageFolio 2.1 - http://www.imagefolio.com -->

<script language="JavaScript1.1">
<!-- Begin
function right(e) {
if (navigator.appName == 'Netscape' && 
(e.which == 2 \|\| e.which == 3)) {
alert('$protection_message');
return false;
}
else if (navigator.appName == 'Microsoft Internet Explorer' && 
(event.button==2 \|\| event.button == 3)) {
alert('$protection_message');
return false;
}
return true;
}
document.onmousedown=right;
if (document.layers) window.captureEvents(Event.MOUSEDOWN);
window.onmousedown=right;
//  End -->
</script>
|; 
}

###############################################################################
# PARSE THE FORM
# Parses the form input and returns a hash with all the name
# value pairs. 
###############################################################################
sub parse_form {
   read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
   @pairs = split(/&/, $buffer);
   foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);
      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
         if ($FORM{$name} && ($value)) { $FORM{$name} = "$FORM{$name},$value"; }
         elsif ($value) { $FORM{$name} = $value; }
   }
}
